<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 0.5                                                  |f
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: new_campaign.php $ */

require_once "libs/paloSantoForm.class.php";
require_once "libs/paloSantoDB.class.php";

if (!function_exists('_tr')) {
    function _tr($s)
    {
        global $arrLang;
        return isset($arrLang[$s]) ? $arrLang[$s] : $s;
    }
}

function _moduleContent(&$smarty, $module_name)
{
    global $arrConf;
    global $arrLang;
    global $arrConfig;
  
    include_once "modules/$module_name/configs/default.config.php";
    include_once "modules/$module_name/libs/paloSantoRegisterKey.class.php";

    // Obtengo la ruta del template a utilizar para generar el filtro.
    $base_dir = dirname($_SERVER['SCRIPT_FILENAME']);
    $templates_dir = (isset($config['templates_dir']))?$config['templates_dir']:'themes';
    $local_templates_dir = "$base_dir/modules/$module_name/".$templates_dir.'/'.$config['theme'];

    // Obtengo el idioma actual utilizado en la aplicacion.
    $language = get_language();
    $script_dir = dirname($_SERVER['SCRIPT_FILENAME']);

    // Include language file for EN, then for local, and merge the two.
    $lang = NULL;
    include_once("modules/$module_name/lang/en.lang");
    $lang_file="modules/$module_name/lang/$language.lang";
    if (file_exists("$script_dir/$lang_file")) {
        $arrLanEN = $lang;
        include_once($lang_file);
        $lang = array_merge($arrLanEN, $lang);
    }
    $arrLang = array_merge($arrLang, $lang);

    $smarty->assign('MODULE_NAME', $module_name);

    /* La interfaz de registro consiste de varias pantallas. La primera informa
       sobre la presencia o ausencia de una licencia G.729 indicada por archivos
       en la ruta /var/lib/asterisk/licenses/ . La segunda muestra el contenido
       del archivo de licencia de Digium para G.729, de forma que el usuario
       pueda aceptarla o no. La tercera pantalla es el formulario para ingresar
       los datos del cliente y el valor de la clave entregada por Digium. Luego
       se ejecuta el programa 'register.g729' antes de mostrar la cuarta 
       pantalla que muestra la salida del programa y éxito o fracaso al 
       registrar, con opción a volver a la primera pantalla. 
     */

    $sPaso = 0;
    if (isset($_GET['paso_registro']) && in_array($_GET['paso_registro'], array(1, 2, 3)))
        $sPaso = $_GET['paso_registro'];
    if (isset($_POST['paso_registro']) && in_array($_POST['paso_registro'], array(1, 2, 3)))
        $sPaso = $_POST['paso_registro'];
      
    switch ($sPaso) {
    case 0:
    default:
        return mostrarReporteLicencias($smarty, $local_templates_dir, $module_name);
    case 1:
        return mostrarAcuerdoLicencia($smarty, $local_templates_dir, $module_name);
    case 2:
        return mostrarFormularioNuevaLicencia($smarty, $local_templates_dir, $module_name);
    }
}

function mostrarReporteLicencias(&$smarty, $local_templates_dir, $module_name)
{
    require_once "libs/paloSantoGrid.class.php";

    $oReg = new paloSantoRegisterKey('/usr/sbin/register.skype');
    $listaLicencias = $oReg->listarLicencias('S4A');

    $smarty->assign('ETIQUETA_AGREGAR_LICENCIA', _tr('Add New License'));

    $arrColumnas = array(
        array('name' => _tr('Filename')),
        array('name' => _tr('Key-ID')),
        array('name' => _tr('Product')),
        array('name' => _tr('Channels')),
        array('name' => _tr('Expiration Date')),
    );
    $arrData = array();
    foreach ($listaLicencias as $infoLicencia) {
        $arrData[] = array(
            $infoLicencia['Filename'],
            $infoLicencia['Key-ID'],
            $infoLicencia['Product'],
            isset($infoLicencia['Channels']) ? $infoLicencia['Channels'] : '('._tr('Unknown').')',
            isset($infoLicencia['ExpDate']) ? $infoLicencia['ExpDate'] : '('._tr('No expiration date').')',            
        );
    }
    $total = count($listaLicencias); $offset = 0; $limit = $total;
    $arrGrid = array(
        "title"    =>  _tr('Skype License Report'),
	    "icon"     => "images/list.png",
	    "width"    => "99%",
	    "start"    => ($total==0) ? 0 : $offset + 1,
	    "end"      => ($offset+$limit)<=$total ? $offset+$limit : $total,
	    "total"    => $total,
	    "columns"  => $arrColumnas
	    );
    $oGrid = new paloSantoGrid($smarty);
    $oGrid->showFilter($smarty->fetch("$local_templates_dir/filter_licensereport.tpl"));
    return $oGrid->fetchGrid($arrGrid, $arrData, array());
}

function mostrarAcuerdoLicencia(&$smarty, $local_templates_dir, $module_name)
{
    $oReg = new paloSantoRegisterKey('/usr/sbin/register.skype');
    
    $smarty->assign(array(
        'LICENSE_TEXT'      =>  wordwrap(file_get_contents($oReg->localizarAcuerdoLicencia('asterisk-chan-skype')), 81),
        'ETIQUETA_REGRESAR' =>  _tr('Return to start'),
        'ETIQUETA_ACEPTAR'  =>  _tr('Accept License'),
    ));
    return $smarty->fetch("$local_templates_dir/display_license.tpl");
}

function mostrarFormularioNuevaLicencia($smarty, $local_templates_dir, $module_name)
{
    $oReg = new paloSantoRegisterKey('/usr/sbin/register.skype');
    
    if (isset($_POST['cancel'])) {
        Header('Location: ?menu='.$module_name);
        return NULL;
    }
    $smarty->assign(array(
        'ETIQUETA_REGRESAR' =>  _tr('Return to start'),
        'ETIQUETA_REGISTRAR'  =>  _tr('Register License'),
        'NOTA_INTERNET'     =>  _tr('Note: a working Internet connection MUST be set up in order for the registration process to succeed.'),
        'ETIQUETA_CAMPO_REQUERIDO'  =>  _tr('Required field'),
    ));
    $arrFormElements = array(
        "txt_license_key"  => array
        (
            "LABEL"                     => _tr('License Key'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "ereg",
            "VALIDATION_EXTRA_PARAM"    => "^S4A-[[:alnum:]]+$"
        ),
        "txt_first_name"  => array
        (
            "LABEL"                     => _tr('First Name'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_last_name"  => array
        (
            "LABEL"                     => _tr('Last Name'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_company"  => array
        (
            "LABEL"                     => _tr('Company'),
            "REQUIRED"                  => "no",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_address1"  => array
        (
            "LABEL"                     => _tr('Address 1'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_address2"  => array
        (
            "LABEL"                     => _tr('Address 2'),
            "REQUIRED"                  => "no",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_city"  => array
        (
            "LABEL"                     => _tr('City'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_state"  => array
        (
            "LABEL"                     => _tr('State'),
            "REQUIRED"                  => "no",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_post_code"  => array
        (
            "LABEL"                     => _tr('Post Code'),
            "REQUIRED"                  => "no",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_country"  => array
        (
            "LABEL"                     => _tr('Country'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "text",
            "VALIDATION_EXTRA_PARAM"    => ""
        ),
        "txt_phone"  => array
        (
            "LABEL"                     => _tr('Phone'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "ereg",
            "VALIDATION_EXTRA_PARAM"    => "^[[:digit:]]+$"
        ),
        "txt_email"  => array
        (
            "LABEL"                     => _tr('E-Mail'),
            "REQUIRED"                  => "yes",
            "INPUT_TYPE"                => "TEXT",
            "INPUT_EXTRA_PARAM"         => "",
            "VALIDATION_TYPE"           => "ereg",
            "VALIDATION_EXTRA_PARAM"    => "^[[:alnum:]_]+@[[:alnum:]._]+$"
        ),
    );
    $oForm = new paloForm($smarty, $arrFormElements);
    if (isset($_POST['register'])) {
        if (!$oForm->validateForm($_POST)) {
            $smarty->assign("mb_title", _tr("Validation Error"));
            $arrErrores=$oForm->arrErroresValidacion;
            $strErrorMsg = '<b>'._tr('The following fields contain errors').'</b><br/>';
            foreach($arrErrores as $k => $v) {
                $strErrorMsg .= "$k, ";
            }
            $smarty->assign("mb_message", $strErrorMsg);
        } else {
            $paramRegistro = array();
            foreach (array('license_key', 'first_name', 'last_name', 'company', 
                'address1', 'address2', 'city', 'state', 'post_code', 'country', 
                'phone', 'email') as $key) {
                if (isset($_POST['txt_'.$key])) $paramRegistro[$key] = $_POST['txt_'.$key];
            }
            $bExito = $oReg->registerDigium($paramRegistro['license_key'], $paramRegistro);
            if ($bExito) {
                Header("Location: ?menu=$module_name");
            } else {
                return _tr('Unable to complete registration. Output of session follows:').'<br/><font color="#ff0000">'.$oReg->errMsg.'</font><br/><pre>'.$oReg->sContenidoTotal.'</pre>';
            }
        }
    }

    return $oForm->fetchForm("$local_templates_dir/form_license.tpl", _tr('Registration Information'), $_POST);
}


?>
